import java.applet.Applet;
import java.awt.*;
import jv.object.PsConfig;
import jv.object.PsMainFrame;
import jv.project.PvDisplayIf;
import jv.viewer.PvViewer;

public class PaTexturePlane extends Applet implements Runnable
{
    public Frame m_frame;
    protected PvViewer m_viewer;
    private String m_drawString;
	
	
    public void stop()
    {
        m_viewer.stop();
    }

    public void startFromThread()
    {
        if (m_viewer != null)
        {
            m_viewer.start();
        }
    }

    public void paint(Graphics g)
    {
        g.setColor(Color.blue);
        g.drawString(PsConfig.getProgramAndVersion(), 20, 40);
        g.drawString(m_drawString, 20, 60);
    }

    public PaTexturePlane()
    {
        m_frame = null;
        m_drawString = "Initializing ...";
    }

    public void destroy()
    {
        m_viewer.destroy();
    }

    public static void main(String args[])
    {
        PaTexturePlane applet = new PaTexturePlane();
        PsMainFrame frame = new PsMainFrame(applet, args);
        applet.m_frame = frame;
        applet.init();
        frame.setBounds(new Rectangle(420, 5, 640, 550));
        frame.setVisible(true);
    }

    public String getAppletInfo()
    {
        return "Name: " + getClass().getName() + "\r\n" + "Author: " + "Humberto Jos Bortolossi.\n";
    }

    public void run()
    {
        String imageFileName = getParameter("imageFileName"); 	
        double imageWidth = Double.valueOf(getParameter("imageWidth")).doubleValue();
        double imageHeight = Double.valueOf(getParameter("imageHeight")).doubleValue();               
        double dist = Double.valueOf(getParameter("dist")).doubleValue();               
    	
        m_viewer = new PvViewer(this, m_frame);
        PjTexturePlane pjtextureplane = new PjTexturePlane(imageFileName, imageWidth, imageHeight, dist);
        m_viewer.addProject(pjtextureplane);
        m_viewer.selectProject(pjtextureplane);
        setLayout(new BorderLayout());
        PvDisplayIf display = m_viewer.getDisplay();
        add((Component) display, "Center");
        validate();
        m_viewer.showPanel(13);
        startFromThread();
    }

    public void init()
    {
        Thread thread = new Thread(this, "JavaView: inititialize applet");
        thread.setPriority(5);
        thread.start();
    }
}
